/*

The Life of a Geek
Copyright (C) 2003 Daniel Quintiliani

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can e-mail Daniel Quintiliani at coredump@coredumpcentral.org

commands.cc: The commands the menus call.

5/21/03: Daniel Quintiliani <coredump@coredumpcentral.org>: CmdWasteTime() 
updated.
5/20/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Text file transition
(almost) complete.
4/24/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed a bug where
only one energy drink would be bought instead of what user specified.
4/7/03: Daniel Quintiliani <coredump@coredumpcentral.org>: To be more
considerate, replaced all bools with ints.

*/

#include <iostream>
#include <stdlib.h>
#include <time.h>
#include "func.h"

using namespace std;

void CmdWasteTime(Geek &geek, Computer &comp)
{
	srand((unsigned)time(NULL));
	int n = rand() % 11 + 1;
	
	cout << endl;
	
	switch(n)
	{
		case 1:
		{
			cout << readfromfile(WASTEFILE,"!WASTE1",0);
			break;
		}
		case 2:
		{
			cout << readfromfile(WASTEFILE,"!WASTE2",0);
			break;
		}
		case 3:
		{
			cout << readfromfile(WASTEFILE,"!WASTE3",0);
			break;
		}
		case 4:
		{
			cout << readfromfile(WASTEFILE,"!WASTE4",0);
			break;
		}
		case 5:
		{
			cout << readfromfile(WASTEFILE,"!WASTE5",0);
			break;
		}
		case 6:
		{
			cout << readfromfile(WASTEFILE,"!WASTE6",0);
			break;
		}
		case 7:
		{
			cout << readfromfile(WASTEFILE,"!WASTE7",0);
			break;
		}
		case 8:
		{
			cout << readfromfile(WASTEFILE,"!WASTE8",0);
			int sec = rand() % 100 + 1;
			if( sec <= 20 && comp.GetSecurity() < (comp.GetMaxHealth() / 4) )
			{
				cout << readfromfile(WASTEFILE,"!WASTE8SEC",0);
				comp.SetSecurity(comp.GetSecurity() + 1);
			}
			break;
		}
		case 9:
		{
			cout << readfromfile(WASTEFILE,"!WASTE9",0);
			break;
		}
		case 10:
		{
			cout << readfromfile(WASTEFILE,"!WASTE10",0);
			break;
		}
		case 11:
		{
			cout << readfromfile(WASTEFILE,"!WASTE11",0);
			break;
		}
	}

	geek.SetEnergy(geek.GetEnergy() - 10);

}

void CmdSpeedClass(Geek &geek, Computer &comp)
{
	geek.SetMoney(geek.GetMoney() - 1500);
	geek.SetEducation(geek.GetEducation() + 1);	
	FuncGenAttack(comp, 20);
}

void CmdWork(Geek &geek, Computer &comp)
{
	srand((unsigned)time(NULL));
	int n = rand() % 5 + 1;

	cout << readfromfile(JOBFILE,"!JMAIN",1);

	switch(n)
	{
		case 1:
			cout << readfromfile(JOBFILE,"!JOB1",0);
			break;
		case 2:
			cout << readfromfile(JOBFILE,"!JOB2",0);
			break;
		case 3:
			cout << readfromfile(JOBFILE,"!JOB3",0);
			break;
		case 4:
			cout << readfromfile(JOBFILE,"!JOB4",0);
			break;
		case 5:
			cout << readfromfile(JOBFILE,"!JOB5",0);
			break;
	}

	float Profit = (float)(rand() % 400 + 100);

	geek.SetMoney(geek.GetMoney() + Profit);
	cout << readfromfilevars(JOBFILE,"!JOBEARN",0,geek,comp,0,Profit,"","","");	

	FuncGenAttack(comp, 40);
}

void CmdBuyEnergyDrink(Geek &geek, int n)
{
	geek.SetMoney(geek.GetMoney() - (10 * n));
	geek.SetEnergyDrinks(geek.GetEnergyDrinks() + n);
}

void CmdDrinkEnergyDrink(Geek &geek)
{
	geek.SetEnergyDrinks(geek.GetEnergyDrinks() - 1);
	geek.SetEnergy(geek.GetEnergy() + 25);
}

void CmdHack(Geek &geek, Computer &comp)
{
	// Not written yet.
	cout << "\nNot written yet." << endl;
	// geek.SetEnergy(geek.GetEnergy() - 50);
}

void CmdAntiVirus(Geek &geek, Computer &comp)
{
	geek.SetMoney(geek.GetMoney() - 15.0);
	comp.SetInfected(1);
	comp.SetHealth(comp.GetMaxHealth());
}

void CmdSleep(Geek &geek, Computer &comp)
{
	geek.SetEnergy(geek.GetEnergy() + 50);
	FuncGenAttack(comp, 60);
}
