/*

The Life of a Geek
Copyright (C) 2003 Daniel Quintiliani

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can e-mail Daniel Quintiliani at coredump@coredumpcentral.org

func.cc: Misc functions

5/21/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated 
FuncGenAttack().
5/20/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added 
readfromfilevars(), inttostring(), removed FuncGenGameName() and FuncGenEmu(),
removed the duplicate, unused FuncGenAttack() text file transition now (almost)
complete.
4/24/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added 
readfromfile().
4/7/03: Daniel Quintiliani <coredump@coredumpcentral.org>: To be more
considerate replaced all bools with ints, added gpl_check_and_strlwr().

*/

#include <iostream>
#include <string>
#include <string.h>
#include <fstream>
#include <sstream>
#include <stdlib.h>
#include <time.h>
#include "func.h"
#include "gpl.h"

#ifndef HAVE_STRLWR
#include "strlwr.h"
#endif

using namespace std;

void FuncGenAttack(Computer &comp, int n)
{
	srand((unsigned)time(NULL));
	int n2 = rand() % 100;

	if( n2 <= n )
	{
		int n3 = rand() % 100;
		if( n3 < 50 )
		{
			Geek geek;
			int n4 = rand() % (comp.GetMaxHealth() / 2) -
				comp.GetSecurity();
			if(n4<0)n4=0;
			comp.SetHealth(comp.GetHealth() - n4);
			cout << readfromfilevars(MAINFILE,"!ATTACK",0,geek,
				comp,n4,0,"","","");
		}
		else
		{
			comp.SetInfected(0);
			cout << readfromfile(MAINFILE,"!ATTVIR",0) << endl;
		}
	}
}

char* gpl_check_and_strlwr(string& s)
{
	char* sz = (char*)s.c_str();
	strlwr(sz);
	s = sz;
	gpl_check(s.c_str());
	return sz;
}

const char* readfromfile(const char* filename, const char* id, int newline)
{
	ifstream ifs(filename);
	string Buffer;
	string Buffer2;

	int eof;
	ifs >> eof;
	getline(ifs,Buffer);
	int n = 0;

	while(n<eof-1)
	{
		string StrFromFile;
		ifs >> StrFromFile;
		getline(ifs,Buffer);
		
		if(strcmp(StrFromFile.c_str(),id)==0)
		{
			if(Buffer == " $END")
				n = eof;
			else
			{
				for(unsigned n2=0;n2<Buffer.size();n2++)
					if(n2 > 0)
						Buffer2 += Buffer[n2];
			
				if(newline == 0)
					Buffer2+='\n';	
			}
		}
		n++;
	}

	ifs.close();
	return Buffer2.c_str();
}

const char* readfromfilevars(const char* filename, const char* id, int newline,
			Geek geek, Computer comp, int intvar,
			float floatvar, const char* cstrvar,
			const char* YInfected, const char* NInfected)
{
        ifstream ifs(filename);
        string Buffer;
	string Buffer2;

        int eof;
        ifs >> eof;
        getline(ifs,Buffer);
        int n = 0;

        while(n<eof-1)
        {
                string StrFromFile;
                ifs >> StrFromFile;
                getline(ifs,Buffer);

                if(strcmp(StrFromFile.c_str(),id)==0)
                {
                        if(Buffer == " $END")
                                n = eof;
                        else
                        {
                                for(unsigned n2=0;n2<Buffer.size();n2++)
				{
                                        if(n2 > 0)
                                        {
						if( Buffer[n2] == '$' && Buffer[n2+1] == '0')
						{
						Buffer2 += inttostring(intvar);
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='1')
						{
						Buffer2 += floattostring(floatvar);
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='2')
						{
						Buffer2 += cstrvar;
						n2++;
						}
					        else if( Buffer[n2] == '$' && Buffer[n2 + 1] == 'a' )
						{
						Buffer2 += inttostring(geek.GetEnergy());
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='b')
						{
						Buffer2 += floattostring(geek.GetMoney());
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='c')
						{
						Buffer2 += geek.GetName();
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='d')
						{
						Buffer2+=inttostring(geek.GetEnergyDrinks());
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='e')
						{
						Buffer2+=inttostring(geek.GetEducation());
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='m')
						{
						if(comp.GetInfected() == 0)
							Buffer2+=YInfected;
						else
							Buffer2+=NInfected;
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='n')
						{
						Buffer2+=inttostring(comp.GetHealth());
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='o')
						{
						Buffer2+=inttostring(comp.GetMaxHealth());
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='p')
						{
						Buffer2+=inttostring(comp.GetSecurity());
						n2++;
						}
						else if(Buffer[n2]=='$'&&Buffer[n2+1]=='V')
						{
						Buffer2+=LIFEGEEK_VERSION;
						n2++;
						}
						else
						{
						Buffer2 += Buffer[n2];
						}
					}
				}
				if(newline==0)
                			Buffer2+='\n';
              		}
		}
                n++;
        }

        ifs.close();
	return Buffer2.c_str();
}

const char* inttostring(int n)
{
	ostringstream os;
	os << n;
	return (os.str()).c_str();
}

const char* floattostring(float f)
{
	ostringstream os;
	os << f;
	return (os.str()).c_str();
}
